#!/usr/bin/env python
# -*- coding: utf-8 -*-

#    Copyright (C) <2011>  <Sebastian Kacprzak> <naicik |at| gmail |dot| com>

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

__author__="Sebastian Kacprzak <naicik at gmail.com>"
__date__ ="$2011-01-22 17:11:03$"

class AbstractPlugin():
    """Extending this class is suggested way of writting plugins.
    It defines simple constructor and progress method
    that takes care of informing callback about upload status.

    Do note that upload method have to be overriden.
    It is included in this class only as a information
    for programmers about parameters and expected functionality
    of methods that overrides it.
    """
    #NAME = example.com
    #acceptedFiletypes = ["png","jpg"]
    #canUsePassword = False

    def __init__(self, fileNumber, progressCallbackFunction):
        self.fileNumber = fileNumber
        self.progressCallbackFunction = progressCallbackFunction

    def progress(self, download_t, download_d, upload_t, upload_d):
        """passes self.fileNumber and arguments to self.progressCallbackFunction
        upload_t - total size to be uploaded
        upload_d - total size already uploaded
        """
        self.progressCallbackFunction(self.fileNumber, download_t, download_d, upload_t, upload_d)

    def upload(self, file, callbackFunction, username = None, password = None):
        """Uploads file, and passed links to callbackFunction.
        Optionaly this method may call self.progress to inform about upload status"""
        raise Exception("This method should be overriden")
        #callbackFunction(links,self.fileNumber,file)




